# Tree Controller

Tools and systems for changing ages, types, colors, growth and seasonal behaviors for trees and wild bushes.

Improvements to plopping and brushing trees and wild bushes including: age choices (Plop fully grown trees), random rotation, and forest brushes.

Video Demo available on [YouTube](https://www.youtube.com/watch?v=YoyMliyWJQU)

## Dependencies
[Unified Icon Library](https://thunderstore.io/c/cities-skylines-ii/p/algernon/Unified_Icon_Library/)

[BepInExPack](https://thunderstore.io/c/cities-skylines-ii/p/BepInEx/BepInExPack/)

## Detailed Description:
For the context of this description 'tree' includes both trees and wild bushes.

Includes a tree controller tool that lets you change the age or types of existing trees on the following selections:
* Single Tree
* Whole Building or Net
* Radius
* Whole Map

Please note that changing types of trees for networks is not persistant and revert as soon as anything touches the network. 
You cannot change types of trees using 'Single Tree' nor 'Whole Building or Net'. Eventually I may remove the ability to alter types of trees with 'Radius' and 'Whole Map'.

For plopping trees this mod adds choice of age(s) and the option to enable random rotation.

For brushing trees this mod adds choice of age(s) and pre-made sets of trees for forest brushes. The pre-made sets are:
* Deciduous (Exluding Apple and Poplar)
* Evergreen (Pine and Spruce)
* Wild bushes 

Custom sets are a planned feature.

Includes the option to disable tree growth over the whole map but it excludes any trees within specialized lumber industry areas.

Includes the option to make deciduous trees use dead model during winter. The dead model is not scaled based on the actual age of the tree.
Deciduous tree growth is paused during winter. Specialized lumber industry areas are excluded from this feature.

Please note, you must either disable this option or press the 'Safely Remove Button' to remove the mod safely during winter.
During any other season the mod can be readily removed. If you do not enable this option the mod can be readily removed.

Includes the option to use and create custom seasonal foliage colors. You can assign RGB values in CSV files that will be created in your mod folder the first time you run the mod.
Don't bother altering with the Alpha value at this time.

There is a known problem with an unknown cause related to the 'Teen' aged London Plane tree where the tree will be black in summer, and white in fall.

Algernon and I have collaborated to allow for age selction using the line tool mod.

Cultivated city bushes do not contain the tree component and are not included in any aspect of the mod.

## Support
I will respond on the code modding channels on [**Cities: Skylines modding Discord**](https://discord.gg/ZaH2zjtk).

## Credits 
* yenyang - Mod Author
* Chameleon TBN - Testing, Feedback, Icons, and Logo
* Algernon - Help with UI, Cooperative Development and Code Sharing, Collaboration regarding line tool.
* T.D.W., Klyte45, krzychu124, and Quboid - Cooperative Development and Code Sharing